program second_real_3D_cube_ever;
uses krush2,crt;

{ YES! This cube actually likes a bit like a cube, acts a
  bit like a cube, moves a bit like a cube and doesn't do
  very foolish things like the others i've coded...

  More sophisticated technique, and a sort of a light source.
                                             Enjoy -Krush 95          }

type virtua = array[0..64000] of byte;
     virpnt = ^virtua;
     point  = record x,y,z:real end;

const cube1 : array[1..8,1..3] of integer =

            ( (-1,-1,+1),(+1,-1,+1),(+1,+1,+1),(-1,+1,+1),
              (-1,-1,-1),(+1,-1,-1),(+1,+1,-1),(-1,+1,-1));

      faces : array[1..6,1..4] of word =

            ( (1,2,3,4),(2,6,7,3),(1,5,6,2),     {  Points in counter-    }
              (8,7,6,5),(1,4,8,5),(3,7,8,4));    {  clockwise order.      }

var cube          : array[1..8] of point;
    conv          : array[1..8] of point;
    twod          : array[1..8] of record x,y:integer; end;
    ctb,stb       : array[0..360] of real;
    virscr        : virpnt;
    virseg        : word;
    i,xof,yof,zof : integer;
    x,y,z         : word;
    z1            : array[1..6] of real;


Procedure V_Setup; begin GetMem (VirScr,64000); virseg := seg(virscr^); end;
Procedure V_Free; begin FreeMem (VirScr,64000); end;
procedure V_Flip(source,dest:Word); assembler;
asm; push ds; mov ax, [Dest]; mov es, ax; mov ax, [Source]; mov ds, ax;
xor si, si; xor di, di; mov cx, 32000; rep movsw; pop ds; end;



procedure SetCube;
begin
  for i:=0 to 360 do begin
    stb[i] := sin(i*pi/180);
    ctb[i] := cos(i*pi/180);
  end;
  for i:=1 to 8 do begin
    cube[i].x := cube1[i,1];
    cube[i].y := cube1[i,2];
    cube[i].z := cube1[i,3];
  end;
  for i:=1 to 20 do setcolor(i,0,0,i*2+15); { This makes it look as if there }
  xof:=160; yof:=100; zof:=9;               { was a lightsource at the view- }
end;                                        { point.                         }

procedure Rotatepoints(Xan,Yan,Zan : integer);
var i,j,k:integer ; tmp: point;
begin
  for i:=1 to 8 do begin
    tmp.x := cube[i].x;
    tmp.y := cube[i].y*ctb[Xan] - cube[i].z*stb[Xan];
    tmp.z := cube[i].y*stb[Xan] + cube[i].z*ctb[Xan];
    conv[i] := tmp;

    tmp.x := conv[i].x*ctb[Yan] - conv[i].z*stb[Yan];
    tmp.z := conv[i].x*stb[Yan] + conv[i].z*ctb[Yan];
    conv[i] := tmp;

    tmp.x := conv[i].x*ctb[Zan] - conv[i].y*stb[Zan];
    tmp.y := conv[i].x*stb[Zan] + conv[i].y*ctb[Zan];
    conv[i] := tmp;

  end;
end;


procedure Drawpoints;
var i,j,k:integer; tmp:real;
begin
  for i:=1 to 8 do begin
    tmp := conv[i].z+zof;
    twod[i].x := round((conv[i].x*256)/ tmp+xof);
    twod[i].y := round((conv[i].y*256)/ tmp+yof);
  end;
  for i:=1 to 6 do begin
    z1[i]:=(conv[faces[i,1]].x-conv[faces[i,2]].x) * (conv[faces[i,1]].y-conv[faces[i,3]].y);
    z1[i]:=z1[i]-((conv[faces[i,1]].y-conv[faces[i,2]].y) * (conv[faces[i,1]].x-conv[faces[i,3]].x));

    if z1[i]<=-0.4 then
      drawpoly (twod[faces[i,1]].x,twod[faces[i,1]].y,
                twod[faces[i,2]].x,twod[faces[i,2]].y,
                twod[faces[i,3]].x,twod[faces[i,3]].y,
                twod[faces[i,4]].x,twod[faces[i,4]].y,round(z1[i]*-5),virseg)
  end;
end;



begin
  Screenmode($13);
  SetCube; V_Setup; Fillchar(mem[virseg:0],64000,0);
  repeat
    Rotatepoints(x,y,z);
    Drawpoints;
    V_Flip(virseg,$A000);
    Fillchar(mem[virseg:0],64000,0);
    if x<360 then inc(x,1) else x:=0;
    if y<360 then inc(y,3) else y:=0;
    if z<360 then inc(z,1) else z:=0;
  until keypressed;
  Screenmode($3); V_Free; textcolor(cyan);
  writeln('Vector cube with simple lightsource.        Enjoy -Krush 95');
  writeln;
end.