program second_real_3D_cube_ever;
uses krush2,crt;

{ YES! This cube actually likes a bit like a cube, acts a
  bit like a cube, moves a bit like a cube and doesn't do
  very foolish things like the others i've coded...

  More sophisticated technique, and a sort of a light source.
                                             Enjoy -Krush 95          }

type virtua = array[0..64000] of byte;
     pic1   = array[0..64000] of byte;
     pal1   = array[0..768] of byte;
     virpnt = ^virtua;
     point  = record x,y,z:real end;

const numpoints = 6;
      numplanes = 8;

      tri1 : array[1..numpoints,1..3] of integer =

            ( (-1,+0,+1),(+1,+0,+1),(+1,+0,-1),
              (-1,+0,-1),(+0,+2,+0),(+0,-2,+0));

      faces : array[1..numplanes,1..3] of word =

            ( (1,2,5),(2,3,5),(3,4,5),(4,1,5),     {  Points in counter-    }
              (6,2,1),(6,3,2),(6,4,3),(6,1,4));    {  clockwise order.      }

var tri           : array[1..numpoints] of point;
    conv          : array[1..numpoints] of point;
    twod          : array[1..numpoints] of record x,y:integer; end;
    ctb,stb       : array[0..360] of real;
    offset        : array[0..314] of record x,z:integer; end;
    pal           : ^pal1;
    pic           : ^pic1;
    virscr        : virpnt;
    virseg        : word;
    i,xof,yof,zof : integer;
    x,y,z,count   : word;
    z1            : real;
    half          : byte;


Procedure V_Setup; begin GetMem (VirScr,64000); virseg := seg(virscr^); end;
Procedure V_Free; begin FreeMem (VirScr,64000); end;
procedure V_Flip(source,dest:Word); assembler;
asm; push ds; mov ax, [Dest]; mov es, ax; mov ax, [Source]; mov ds, ax;
xor si, si; xor di, di; mov cx, 32000; rep movsw; pop ds; end;


procedure SetCube;
var a,b,c:real; count,code:integer;
    f:text; num:string;
begin
  getmem(pic,64000);
  getmem(pal,768);
  Loadpcx('vectbkgn.pcx',pal,pic);
  for i:=0 to 255 do setcolor(i,pal^[i*3],pal^[i*3+1],pal^[i*3+2]);
  for i:=1 to 20 do setcolor(192+i,i*2+15,0,i+15);
  for i:=0 to 360 do begin
    stb[i] := sin(i*pi/180);
    ctb[i] := cos(i*pi/180);
  end;
  for i:=1 to numpoints do begin
    tri[i].x := tri1[i,1];
    tri[i].y := tri1[i,2];
    tri[i].z := tri1[i,3];
  end;
  xof:=60; yof:=100; zof:=20;
  assign(f,'route.dat');
  reset(f);
  for i:=0 to 314 do begin
    readln(f,num);
    val(num,offset[i].x,code);
    readln(f,num);
    val(num,offset[i].z,code);
  end;
  for i:=0 to 314 do begin
    offset[i].x:=offset[i].x+160;
    offset[i].z:=offset[i].z+22;
  end;
  close(f);

end;

procedure Rotatepoints(Xan,Yan,Zan : integer);
var i,j,k:integer ; tmp: point;
begin
  for i:=1 to numpoints do begin
    tmp.x := tri[i].x;
    tmp.y := tri[i].y*ctb[Xan] - tri[i].z*stb[Xan];
    tmp.z := tri[i].y*stb[Xan] + tri[i].z*ctb[Xan];
    conv[i] := tmp;

    tmp.x := conv[i].x*ctb[Yan] - conv[i].z*stb[Yan];
    tmp.z := conv[i].x*stb[Yan] + conv[i].z*ctb[Yan];
    conv[i] := tmp;

    tmp.x := conv[i].x*ctb[Zan] - conv[i].y*stb[Zan];
    tmp.y := conv[i].x*stb[Zan] + conv[i].y*ctb[Zan];
    conv[i] := tmp;

  end;
end;


procedure Drawpoints;
var i,j,k:integer; tmp:real;
begin
  for i:=1 to numpoints do begin
    tmp := conv[i].z+zof;
    twod[i].x := round((conv[i].x*256)/ tmp+xof);
    twod[i].y := round((conv[i].y*256)/ tmp+yof);
  end;
  for i:=1 to numplanes do begin
    z1:=(conv[faces[i,1]].x-conv[faces[i,2]].x) * (conv[faces[i,1]].y-conv[faces[i,3]].y);
    z1:=z1-((conv[faces[i,1]].y-conv[faces[i,2]].y) * (conv[faces[i,1]].x-conv[faces[i,3]].x));

    if z1<=-0.4 then
      drawpoly (twod[faces[i,1]].x,twod[faces[i,1]].y,
                twod[faces[i,2]].x,twod[faces[i,2]].y,
                twod[faces[i,3]].x,twod[faces[i,3]].y,
                twod[faces[i,3]].x,twod[faces[i,3]].y,192+round(z1*-4),virseg)
  end;
end;



begin
  Screenmode($13); SetCube; V_Setup;
  Fillchar(mem[virseg:0],64000,0); count:=0; half:=0;
  repeat
    inc(half);

    Rotatepoints(x,y,z);
    Drawpoints;
    V_Flip(virseg,$A000);
    Move(pic^,mem[virseg:0],63999);
    if x<360 then inc(x,1) else x:=0;
    if y<360 then inc(y,3) else y:=0;
    if z<360 then inc(z,1) else z:=0;

    if half=2 then begin
     if count=314 then count:=0;
     xof:=offset[count].x;
     zof:=offset[count].z;
     inc(count); half:=0;
    end;


    pal^[540]:=pal^[3];pal^[541]:=pal^[4];pal^[542]:=pal^[5];
    for i:=1 to 179 do begin
    pal^[i*3]:=pal^[i*3+3];pal^[i*3+1]:=pal^[i*3+4];pal^[i*3+2]:=pal^[i*3+5];
    end;
    for i:=0 to 180 do setcolor(i,pal^[i*3],pal^[i*3+1],pal^[i*3+2]);


  until keypressed;
  Screenmode($3); V_Free; textcolor(cyan);
  writeln('Vector cube with simple lightsource and background.');
  writeln('A bit jerky... eh?                                 ');
  writeln('                                    Enjoy, Krush 95');
  writeln;
end.